import numpy as np
import sys,glob,re,os

I = 1
oned = 1
#I = int(sys.argv[1])
#oned = int(sys.argv[2])

r_train_region = 0.12  
r_valid_region = 0.04
r_test_region = 0.04

W = 100

datad = "data/NA_NORM_6190_Bioclim_ASCII/W%s"%(W)

bns = ["AHM"]
    
#od = "data/NAall/I%sl%sv%st%so%s/"%(I,r_train_region,r_valid_region,r_test_region,oned)
od = "data/NA/I%sl%sv%st%so%s/"%(I,r_train_region,r_valid_region,r_test_region,oned)
os.makedirs(od,exist_ok=True)

dats = []
print(datad)
fns = glob.glob("%s/%s/*.npz"%(datad,bns[0]))
for fn in fns:
    dats.append(os.path.basename(fn))
dats = np.array(dats)
print(dats)
print(len(dats))

n_region = len(dats)
n_train_region = int(r_train_region*n_region)
n_valid_region = int(r_valid_region*n_region)
n_test_region = int(r_test_region*n_region)
n_task = len(bns)

heads = ['train','valid']
elev_head = "%s/ele"%(datad)


eps = 1e-5
if oned == 1:
    x = np.expand_dims(np.arange(W,dtype=float),1)
else:
    x = np.concatenate((np.expand_dims(np.repeat(np.expand_dims(np.arange(W,dtype=float),1),W,axis=1),axis=2),
                        np.expand_dims(np.repeat(np.expand_dims(np.arange(W,dtype=float),0),W,axis=0),axis=2)),axis=2)
    x = x.reshape(-1,2)
x = (x-np.mean(x,0,keepdims=True))/(np.std(x,0,keepdims=True)+eps)
    

for i in range(I):
    for bn in bns:
        perm_region = np.random.permutation(len(dats))
        train_region_idxs = perm_region[:n_train_region]
        valid_region_idxs = perm_region[n_train_region:n_train_region+n_valid_region]
        test_region_idxs = perm_region[n_train_region+n_valid_region:n_train_region+n_valid_region+n_test_region]

        train_xs = []
        train_ys = []
        for idx,train_region_idx in enumerate(train_region_idxs):
            fn = "%s/%s/%s"%(datad,bn,dats[train_region_idx])
            y = np.load(fn)['x']
            y = (y-y.mean())/(y.std()+eps)
            y = y.reshape(-1,1)
            if oned == 0:
                fn = "%s/ele/%s"%(datad,dats[train_region_idx])
                ele = np.load(fn)['x']
                ele = (ele-ele.mean())/(ele.std()+eps)
                ele = ele.reshape(-1,1)
                xele = np.concatenate((x,ele),1)
            else:
                xele = x
            perm = np.random.permutation(x.shape[0])
            train_xs.append(xele[perm,:])
            train_ys.append(y[perm,:])

        valid_xs = []
        valid_ys = []
        for idx,valid_region_idx in enumerate(valid_region_idxs):
            fn = "%s/%s/%s"%(datad,bn,dats[valid_region_idx])
            y = np.load(fn)['x']
            y = (y-y.mean())/(y.std()+eps)
            y = y.reshape(-1,1)
            if oned == 0:
                fn = "%s/ele/%s"%(datad,dats[valid_region_idx])
                ele = np.load(fn)['x']
                ele = (ele-ele.mean())/(ele.std()+eps)
                ele = ele.reshape(-1,1)
                xele = np.concatenate((x,ele),1)
            else:
                xele = x
            perm = np.random.permutation(x.shape[0])
            valid_xs.append(xele[perm,:])
            valid_ys.append(y[perm,:])

        test_xs = []
        test_ys = []
        for idx,test_region_idx in enumerate(test_region_idxs):
            fn = "%s/%s/%s"%(datad,bn,dats[test_region_idx])
            y = np.load(fn)['x']
            y = (y-y.mean())/(y.std()-eps)
            y = y.reshape(-1,1)
            if oned == 0:
                fn = "%s/ele/%s"%(datad,dats[test_region_idx])
                ele = np.load(fn)['x']
                ele = (ele-ele.mean())/(ele.std()-eps)
                ele = ele.reshape(-1,1)
                xele = np.concatenate((x,ele),1)
            else:
                xele = x
            perm = np.random.permutation(x.shape[0])
            test_xs.append(xele[perm,:])
            test_ys.append(y[perm,:])

        odbn = "%s/%s"%(od,bn)
        os.makedirs(odbn,exist_ok=True)            
        ofn = "%s/i%s.npz"%(odbn,i)
        np.savez(ofn,train_xs=train_xs,valid_xs=valid_xs,test_xs=test_xs,
                 train_ys=train_ys,valid_ys=valid_ys,test_ys=test_ys)
        print(ofn)
